from netgen.csg import Sphere, EllipticCone, Plane, CSGeometry
from netgen.meshing import Pnt, Vec
from ngsolve import Mesh, Draw, specialcf

ratio = 0.02
#ratio = 0.0

ball = Sphere(Pnt(0,0,0), 1)
cone = EllipticCone(a=Pnt(2, 0, 0), vl=Vec(0,0,1), vs=Vec(0,1,0), h=2, r=ratio) \
  * Plane(Pnt(0,0,0), Vec(-1, 0, 0)) * Plane(Pnt(2,0,0), Vec(1,0,0))
pacman = ball - cone

geo = CSGeometry()
geo.Add(pacman)
mesh = Mesh(geo.GenerateMesh(maxh=0.2))

Draw(specialcf.mesh_size, mesh, "h")
mesh.ngmesh.Save("bad_pacman3D.vol")
